From 25de026b3eb32e7457270cd199fe0902876a2715 Mon Sep 17 00:00:00 2001
From: Yuan Fu <casouri@gmail.com>
Date: Thu, 28 Nov 2024 01:51:44 -0800
Subject: [PATCH] Preproc indent POC

---
 lisp/progmodes/c-ts-mode.el | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

diff --git a/lisp/progmodes/c-ts-mode.el b/lisp/progmodes/c-ts-mode.el
index c815ee35501..313dcfb5c05 100644
--- a/lisp/progmodes/c-ts-mode.el
+++ b/lisp/progmodes/c-ts-mode.el
@@ -435,6 +435,24 @@ c-ts-mode--indent-styles
            ((parent-is "labeled_statement")
             c-ts-mode--standalone-grandparent c-ts-mode-indent-offset)
 
+           ,(let (anchor)
+              (list
+               (lambda (_node parent &rest _)
+                 (let ((anchor-node
+                        (cond
+                         ((treesit-node-match-p parent "preproc_ifdef")
+                          (treesit-node-prev-sibling parent))
+                         ((treesit-node-match-p parent "preproc_else")
+                          (treesit-node-prev-sibling
+                           (treesit-node-parent parent))))))
+                   (when anchor-node
+                     (setq anchor (treesit-node-start anchor-node))
+                     ;; If parent is preproc and previous sibling is
+                     ;; if_statement, set anchor and return t.
+                     (treesit-node-match-p anchor-node "if_statement"))))
+               (lambda (&rest _) anchor)
+               c-ts-mode-indent-offset))
+
            ;; Preproc directives
            ((node-is "preproc") column-0 0)
            ((node-is "#endif") column-0 0)
-- 
2.39.5 (Apple Git-151)

